//ページのロードが完了したら
window.addEventListener( 'load' , ()=>
{
	//ボタンを処理する
	document.querySelectorAll( '.ajax-setting-save' ).forEach( ( targetBtn ) =>
	{
		//ajax保存ボタンをクリックしたら
		targetBtn.addEventListener( 'click' , ()=>
		{
			//モーダルを開く
			UIkit.modal( '#mhs-modal-msg' ).show();

			const modal_title		= document.querySelector( '#mhs-modal-msg .uk-modal-title' );
			const modal_body		= document.querySelector( '#mhs-modal-msg .uk-modal-body' );

			modal_title.innerHTML	= '通信中';
			modal_body.innerHTML	= '<p>通信処理が完了するまでしばらくお待ち下さい。</p><div class="uk-flex uk-flex-center"><div uk-spinner></div></div>';


			//ユニークIDを取得
			const uid = targetBtn.dataset.uid;

			//フォームオブジェクトを取得
			const fetchForm = document.querySelector( '#' + uid );

			let fd = new FormData( fetchForm );

			//サーバーに渡す値を追加
			fd.append( 'action' , action );
			fd.append( 'token' , token );

			for(let value of fd.entries() )
			{
				console.log(value);
			}


			//ajax通信
			fetch( admin_ajax_url ,
			{
				method: 'POST',
				cache: 'no-cache' ,
				body: fd
			})
			.then( response =>
			{
				//通信が正常であれば
				if( response.status == 200 )
				{
					//モーダルを一旦閉じる
					UIkit.modal( '#mhs-modal-msg' ).hide();

					//モーダルを開く
					UIkit.modal( '#mhs-modal-msg' ).show();

					const modal_title		= document.querySelector( '#mhs-modal-msg .uk-modal-title' );
					const modal_body		= document.querySelector( '#mhs-modal-msg .uk-modal-body' );

					modal_title.innerHTML	= '通信完了';
					modal_body.innerHTML	= '<p>通信処理が完了しました。</p>';

				}
				//異常であれば
				else
				{
					//モーダルを一旦閉じる
					UIkit.modal( '#mhs-modal-msg' ).hide();

					//モーダルを開く
					UIkit.modal( '#mhs-modal-msg' ).show();

					const modal_title		= document.querySelector( '#mhs-modal-msg .uk-modal-title' );
					const modal_body		= document.querySelector( '#mhs-modal-msg .uk-modal-body' );

					modal_title.innerHTML	= '異常終了';
					modal_body.innerHTML	= '<p class="uk-text-danger">処理が異常終了しました。</p>';
				}

				return response.json();
			})
			.then( data =>
			{
				//モーダルを一旦閉じる
				UIkit.modal( '#mhs-modal-msg' ).hide();

				//モーダルを開く
				UIkit.modal( '#mhs-modal-msg' ).show();

				const modal_title		= document.querySelector( '#mhs-modal-msg .uk-modal-title' );
				const modal_body		= document.querySelector( '#mhs-modal-msg .uk-modal-body' );

				modal_title.innerHTML	= data.status;
				modal_body.innerHTML	= '<p>' + data.msg + '</p>';

				console.log( data );
			})
			.catch( error =>
			{
				console.log( error );
			});

		});

	});



	//タブの保存位置のローカルストレージ名
	const tab_storage_name	= 'mhs-tab_menu-level1';

	//localStorage.removeItem(tab_storage_name);

	//ローカルストレージからタブの保存位置取得する
	const old_tab_pos		= localStorage.getItem( tab_storage_name );


	//保存履歴があれば
	if( old_tab_pos != null )
	{
		UIkit.switcher( '.mhs-tab_head-level1' ).show( old_tab_pos );
	}

	//タブの切り替えを保存する
	UIkit.util.on( '.uk-switcher' , 'show' , function( e )
	{
		const E_tab = this.querySelectorAll( 'ul.uk-switcher.mhs-tab_menu-level1 > li' );

		for( let i = 0; i < E_tab.length; i++ )
		{
			//クラス名を取得
			const class_name = E_tab[ i ].className;

			//空値であればスキップ
			if( class_name == '' ) continue;

			//アクティブクラスが設定されていれば
			if( class_name.indexOf( 'uk-active' ) !== -1 )
			{
				//ローカルストレージにタブの保存位置を保存する
				localStorage.setItem( tab_storage_name , i );

				//ループ終了
				break;
			}
		}
	});



});

/*
const fetchForm = document.querySelector('.fetchForm');
const btn = document.querySelector('.btn');
const url = 'https://jsonplaceholder.typicode.com/posts/';

const postFetch = () => {
    let formData = new FormData(fetchForm);
    for (let value of formData.entries()) {
        console.log(value);
    }

    fetch(url, {
        method: 'POST',
        body: formData
    }).then((response) => {
        if(!response.ok) {
            console.log('error!');
        } 
        console.log('ok!');
        return response.json();
    }).then((data)  => {
        console.log(data);
    }).catch((error) => {
        console.log(error);
    });
};

btn.addEventListener('click', postFetch, false);
*/

jQuery( function( $ )
{
	/* オリジナルアコーディオン */
	$( '.mhs-accordion .toggle' ).on( 'click' , function()
	{
		$( this ).next().slideToggle( 300 );
		$( this ).toggleClass( 'active' );
	});


	//テキストエリアの自動リサイズ
	$( 'textarea.editor' ).on( 'focus' , function( evt )
	{
		if( evt.target.scrollHeight > evt.target.offsetHeight )
		{
			$( evt.target ).height( evt.target.scrollHeight );
		}
		else
		{
			const lineHeight = Number( $( evt.target ).css( 'lineHeight' ).split( 'px' )[0] );

			while( true )
			{
				$( evt.target ).height( $( evt.target ).height() - lineHeight );

				if( evt.target.scrollHeight > evt.target.offsetHeight )
				{
					$( evt.target ).height( evt.target.scrollHeight );

					break;
				}
			}
		}
	});

});
