<?php
defined( 'ABSPATH' ) || exit; 
/*
Description: フィードのインポートとエクスポート関連クラス。
Version: 0.2
Author: 阿修羅ワークス
Author URI: https://wp-plugin.info/
Last Update: 2021-05-27
Changelog: インポート機能に部分インポート機能を追加
2021-05-27 0.2 インポート機能に部分インポート機能を追加
2021-04-14 0.1 初リリース
*/
 class mhs_ImportExport2 {   function FEED_RESET( $FEED_OPTION_KEY , $NOUNCE_KEY , $base_file , $CMD = 'cmd' ) { if(! $FEED_OPTION_KEY or ! $NOUNCE_KEY or ! $base_file ) return;  global $JP;  if( $_POST[ $CMD ] == 'feed-reset' ) {  check_admin_referer( $NOUNCE_KEY );  $JP->UPDATE_OPTION( $FEED_OPTION_KEY , null , 1 ); ?>
<div class="ui positive message">
	<?php echo "<p>フィードをリセットしました。</p>"; ?>
	<p>ページを更新して下さい。</p>
</div>
<?php
 } else { ?>
	<form action="#feed-reset-btn" method="post" class="ui form">
		<?php wp_nonce_field( $NOUNCE_KEY ); ?>
		<input type="hidden" name="<?php echo $CMD; ?>" value="feed-reset">
		<input type="submit" name="submit" id="feed-reset-btn" class="ui button negative" value="リセットする">
	</form>

<script>
jQuery( function( $ )
{
	//リセットボタンをクリックしたら
	$( '#feed-reset-btn' ).on( 'click submit' , function( e )
	{
		//クリックしないなら
		if(! confirm( "本当にリセットしますか？\nこの作業はやり直しができません" ) )
		{
			//送信を停止
			e.preventDefault();
		}
	});

	//インポートボタンをクリックしたら
	$( '#feed-import-btn' ).on( 'click submit' , function( e )
	{
		//クリックしないなら
		if(! confirm( "本当にインポートしますか？\nこの作業はやり直しができません" ) )
		{
			//送信を停止
			e.preventDefault();
		}
	});

});
</script>
<?php
 } }  function FEED_IMPORT( $FEED_OPTION_KEY , $NOUNCE_KEY , $base_file , $file_name = 'import.dat' , $CMD = 'cmd' ) { if(! $FEED_OPTION_KEY or ! $NOUNCE_KEY or ! $base_file ) return;  global $JP;  $uploaded_file = $_FILES[ 'upfile' ][ 'tmp_name' ];  if( $_POST[ $CMD ] == 'feed-import' and is_uploaded_file( $uploaded_file ) ) {  check_admin_referer( $NOUNCE_KEY );  $H_feed_urls = $JP->GET_OPTION( $FEED_OPTION_KEY );  if(! $H_feed_urls ) $H_feed_urls = array();  $save_path = dirname( $base_file ) . "/" . $file_name;  if( move_uploaded_file( $uploaded_file , $save_path ) ) {  @chmod( $save_path , 0644 ); ?>
<div class="ui positive message">
	<?php echo "<p>" . $_FILES[ 'upfile' ][ 'name' ] . " をアップロードしました。</p>"; ?>
	<p>ページを更新して下さい。</p>
</div>
<?php
  $H_feed_urls2 = json_decode( file_get_contents( $save_path ) , true );  if( $_POST[ 'type' ] ) {  $JP->UPDATE_OPTION( $FEED_OPTION_KEY , $H_feed_urls2 , 1 ); }  else {  if( $H_feed_urls and $H_feed_urls2 ) {  $H_merge_feed_urls = array_merge( $H_feed_urls , $H_feed_urls2 );  $JP->UPDATE_OPTION( $FEED_OPTION_KEY , $H_merge_feed_urls , 1 ); }  else if(! $H_feed_urls and $H_feed_urls2 ) {  $JP->UPDATE_OPTION( $FEED_OPTION_KEY , $H_feed_urls2 , 1 ); } } } else { ?>
<div class="ui negative message">
	<div class="header">エラー</div>
	<p>ファイルをアップロードできませんでした。</p>
</div>
<?php
 } }  else if( $_POST[ $CMD ] == 'feed-import' and (! $uploaded_file or ! is_uploaded_file( $uploaded_file ) ) ) { ?>
<div class="ui negative message">
	<div class="header">エラー</div>
	<p>アップロードするファイルがありませんでした。<br>アップロードするファイルを選択して下さい。</p>
</div>
<?php
 } ?>
	<form action="#feed-import-btn" method="post" class="ui form" enctype='multipart/form-data'>
		<?php wp_nonce_field( $NOUNCE_KEY ); ?>
		<input type="hidden" name="<?php echo $CMD; ?>" value="feed-import">

		<div class="field">
			<div class="two fields">

				<div class="field">
					<div class="field">
						<input type="submit" name="submit" id="feed-import-btn" class="ui button negative" value="アップロード">
					</div>
				</div>

				<div class="field">
					<div class="field">
						<input type="file" name="upfile" size="30" />
					</div>
				</div>

			</div>
		</div>


		<div class="inline fields">
			<label for="type">インポート方法</label>

			<div class="field">
				<div class="ui radio checkbox">
					<input type="radio" name="type" checked="" value="0" tabindex="0" class="hidden">
					<label>部分追加置き換え</label>
				</div>
			</div>

			<div class="field">
				<div class="ui radio checkbox">
					<input type="radio" name="type" value="1" tabindex="0" class="hidden">
					<label>全体置き換え</label>
				</div>
			</div>

		</div>

	</form>
<?php
 }  function FEED_EXPORT( $FEED_OPTION_KEY , $NOUNCE_KEY , $base_file , $file_name = 'export.dat' , $CMD = 'cmd' ) { if(! $FEED_OPTION_KEY or ! $NOUNCE_KEY or ! $base_file ) return;  global $JP;  if( $_POST[ $CMD ] == 'feed-export' ) {  check_admin_referer( $NOUNCE_KEY );  $H_feed_urls = $JP->GET_OPTION( $FEED_OPTION_KEY );  if(! $H_feed_urls ) $H_feed_urls = array();  if( $H_feed_urls ) $export_string = json_encode( $H_feed_urls );  $fp = fopen( dirname( $base_file ) . "/$file_name" , "w" );  fwrite( $fp , $export_string );  fclose( $fp );  $url = plugin_dir_url( $base_file ) . $file_name;  $download_link = '<p><a href="{{url}}" download="{{file_name}}" id="feed-export-btn" class="ui button primary">エクスポートデータをダウンロード</a></p>';  $download_link = str_replace( '{{url}}' , $url , $download_link ); $download_link = str_replace( '{{file_name}}' , $file_name , $download_link );  $download_link = preg_replace( '/\{\{.*?\}\}/' , '' , $download_link );  echo $download_link; ?>
<div class="ui success message">
	<div class="header">ダウンロード準備完了</div>
	<p>[ エクスポートデータをダウンロード ] ボタンを押してダウンロードを開始して下さい。</p>
</div>
<?php
 } else { ?>
	<form action="#feed-export-btn" method="post" class="ui form">
		<?php wp_nonce_field( $NOUNCE_KEY ); ?>
		<input type="hidden" name="<?php echo $CMD; ?>" value="feed-export">
		<input type="submit" name="submit" class="ui button positive" value="ダウンロード">
	</form>
<?php
 } }  function DBT( $mode = 0 ) { if( $mode ) { echo "<pre>"; print_r( debug_backtrace() ); echo "</pre>"; } else {  if( is_user_logged_in() ) { echo "<pre>"; print_r( debug_backtrace() ); echo "</pre>"; } } }  function DMPF( $data , $file_name = "test.txt" , $mode = 0 , $max_byte = 1048576 ) {  ob_start(); var_dump( $data ); $result = ob_get_contents(); ob_end_clean();  if( $mode ) { $fp = fopen( dirname(__FILE__) . "/$file_name" , "a" ); $result .= "\n"; }  else { $fp = fopen( dirname(__FILE__) . "/$file_name" , "w" ); }  fwrite( $fp , $result , $max_byte ); fclose( $fp ); }  function DMP( $value , $option = NULL ) {  if( $option == 1 ) { echo "<pre>"; var_dump( $value ); echo "</pre>"; } else if( $option == 2 ) {  if( is_user_logged_in() ) { echo "<pre>"; var_dump( $value ); echo "</pre>"; } }  else {  if( is_user_logged_in() ) { echo "<pre>"; var_dump( $value ); echo "</pre>"; } } } } ?>