<?php
defined( 'ABSPATH' ) || exit; 
/*
Description: Twitter API操作系クラス。
Version: 0.1
Author: 阿修羅ワークス
Author URI: https://wp-plugin.info/
Last Update: 2023-01-18
Changelog: 初リリース
2023-01-18 0.1 初リリース
*/
 require_once( dirname( __FILE__ ) . '/../vendor/autoload.php' ); use Abraham\TwitterOAuth\TwitterOAuth; class mhs_Twitter2 {   function CREATE_OBJECT( $consumer_key , $consumer_secret , $access_token , $access_token_secret ) {  $O_tw = new TwitterOAuth( $consumer_key , $consumer_secret , $access_token , $access_token_secret ); return $O_tw; }  function CHECK_API_TEST( $CMD = 'cmd' , $consumer_key = null , $consumer_secret_key = null , $access_token = null , $access_token_secret = null ) { $H_keys = $_POST[ 'keys' ]; $consumer_key = isset( $H_keys[ 'consumer_key' ] ) ? esc_html( $H_keys[ 'consumer_key' ] ) : $consumer_key; $consumer_secret_key = isset( $H_keys[ 'consumer_secret_key' ] ) ? esc_html( $H_keys[ 'consumer_secret_key' ] ) : $consumer_secret_key; $access_token = isset( $H_keys[ 'access_token' ] ) ? esc_html( $H_keys[ 'access_token' ] ) : $access_token; $access_token_secret = isset( $H_keys[ 'access_token_secret' ] ) ? esc_html( $H_keys[ 'access_token_secret' ] ) : $access_token_secret; ?>
<div class="wrap">
	<h2 class="page-title">Twitter APIキー認証チェック</h2>

		<div class="uk-alert mhs-notice-default">
			<p>Twitter APIキーが有効かどうかをチェックします。<a href="https://developer.twitter.com/en/apps/" target="_blank" rel="noopener">取得したTwitter APIキー</a>を正しく入力して下さい。</p>
		</div>

<?php if( $_POST[ $CMD ] and ( ! $consumer_key or ! $consumer_secret_key or ! $access_token or ! $access_token_secret ) ): ?>

		<div class="uk-alert mhs-notice-negative">
			<p>入力されていないキーがあります。全てのキーを正しく入力して下さい。</p>
		</div>

<?php endif; ?>

	<div class="uk-card uk-card-default uk-card-body" style="border-radius: .5em;">
		<form class="uk-form-horizontal" action="" method="post">

			<div class="uk-margin">
				<label class="uk-form-label">Consumer API key<span class="uk-text-danger"> *</span></label>
				<div class="uk-form-controls">
					<input type="text" class="uk-input" name="keys[consumer_key]" value="<?php echo $consumer_key; ?>" placeholder="Consumer API key">
				</div>
			</div>

			<div class="uk-margin">
				<label class="uk-form-label">Consumer API secret key<span class="uk-text-danger"> *</span></label>
				<div class="uk-form-controls">
					<input type="text" class="uk-input" name="keys[consumer_secret_key]" value="<?php echo $consumer_secret_key; ?>" placeholder="Consumer API secret key">
				</div>
			</div>

			<div class="uk-margin">
				<label class="uk-form-label">Access token<span class="uk-text-danger"> *</span></label>
				<div class="uk-form-controls">
					<input type="text" class="uk-input" name="keys[access_token]" value="<?php echo $access_token; ?>" placeholder="Access token">
				</div>
			</div>

			<div class="uk-margin">
				<label class="uk-form-label">Access token secret<span class="uk-text-danger"> *</span></label>
				<div class="uk-form-controls">
					<input type="text" class="uk-input" name="keys[access_token_secret]" value="<?php echo $access_token_secret; ?>" placeholder="Access token secret">
				</div>
			</div>

			<button class="uk-button uk-button-green" type="submit">チェックする</button>

			<?php wp_nonce_field( $NOUNCE_KEY ); ?>
			<input type="hidden" name="<?php echo $CMD; ?>" value="1">

		</form>
	</div>

<?php
  if( $_POST[ $CMD ] and $consumer_key and $consumer_secret_key and $access_token and $access_token_secret ) { $template = <<< EOM
		<div class="uk-alert mhs-notice-negative">
			<div class="header">認証結果</div>
			<p>エラーコード : {{code}}</p>
			<p>エラー内容 : {{message}}</p>
			<p>エラーコード32 「Could not authenticate you.」と表示される場合は単純にTwitter APIキーの入力が間違っているか、APIキーがまだ承認されていないといった可能性があります。</p>
			<p>エラー内容については<a href="https://developer.twitter.com/en/docs/basics/response-codes" target="_blank" rel="noopener">こちら</a></p>
		</div>

EOM;
 $result = <<< EOM
		<div class="uk-alert mhs-notice-success">
			<div class="header">認証結果</div>
			<p>APIキーは有効です</p>
		</div>

EOM;
 $official_format = <<< EOM
<blockquote class="twitter-tweet" {{DATA_CARDS}} data-lang="{{USER_LANG}}">
<p>{{TWEET_TEXT}}</p>
&mdash; {{USER_NAME}} (@{{SCREEN_NAME}}) <a href="{{URL}}">{{DATE}}</a>
</blockquote>
<script async src="https://platform.twitter.com/widgets.js" charset="utf-8"></script>

EOM;
  $O_tw = new TwitterOAuth( $consumer_key , $consumer_secret_key , $access_token , $access_token_secret );  $O_res = $O_tw->get( 'statuses/home_timeline' , array( 'count' => 10 , 'tweet_mode' => 'extended' ) );  $H_res = json_decode( json_encode( $O_res ) , true );  if( isset( $H_res[ 'errors' ] ) ) { $A_temp = array();  foreach( (array)$H_res[ 'errors' ] as $H_err ) { $template_ = $template; $template_ = str_replace( '{{code}}' , $H_err[ 'code' ] , $template_ ); $template_ = str_replace( '{{message}}' , $H_err[ 'message' ] , $template_ ); $A_temp[] = $template_; }  $result = implode( "\n" , $A_temp ); echo $result; }  else { echo $result; $A_tweets = array();  foreach( (array)$H_res as $H_tweet ) {  $tweet_text = esc_html( $H_tweet[ 'full_text' ] ) ? esc_html( $H_tweet[ 'full_text' ] ) : esc_html( $H_tweet[ 'text' ] );  $id = esc_html( $H_tweet[ 'id_str' ] );  $user_id = esc_html( $H_tweet[ 'user' ][ 'screen_name' ] );  $user_name = esc_html( $H_tweet[ 'user' ][ 'name' ] );  $screen_name= esc_html( $H_tweet[ 'user' ][ 'screen_name' ] );  $date = date_i18n( 'Y年n月j日' , strtotime( $H_tweet[ 'created_at' ] ) ); $date2 = date_i18n( 'Y年m月d日 H:i:s' , strtotime( $H_tweet[ 'created_at' ] ) );  $url = 'https://twitter.com/' . $user_id . '/status/' . $id . '?ref_src=twsrc%5Etfw';  $user_lang = $H_tweet[ 'user' ][ 'lang' ];  $user_description = esc_html( $H_tweet[ 'user' ][ 'description' ] );  $source = esc_html( $H_tweet[ 'source' ] );  $tweet_count = esc_html( $H_tweet[ 'user' ][ 'statuses_count' ] );  $friends_count = esc_html( $H_tweet[ 'user' ][ 'friends_count' ] );  $followers_count = esc_html( $H_tweet[ 'user' ][ 'followers_count' ] );  $retweet_count = esc_html( $H_tweet[ 'retweet_count' ] );  $favourites_count = esc_html( $H_tweet[ 'user' ][ 'favourites_count' ] );  $user_icon = $H_tweet[ 'user' ][ 'profile_image_url_https' ];  $media_url1 = $H_tweet[ 'extended_entities' ][ 'media' ][ 0 ][ 'media_url_https' ]; $media_url2 = $H_tweet[ 'extended_entities' ][ 'media' ][ 1 ][ 'media_url_https' ]; $media_url3 = $H_tweet[ 'extended_entities' ][ 'media' ][ 2 ][ 'media_url_https' ]; $media_url4 = $H_tweet[ 'extended_entities' ][ 'media' ][ 3 ][ 'media_url_https' ]; $H_media_url= array( 'media_url1' => $media_url1 , 'media_url2' => $media_url2 , 'media_url3' => $media_url3 , 'media_url4' => $media_url4 , );  if( $H_tweet[ 'extended_entities' ][ 'media' ] ) { foreach( $H_tweet[ 'extended_entities' ][ 'media' ] as $O_medias ) { $media_url = $O_medias[ 'url' ];  $tweet_text = str_replace( $media_url , '' , $tweet_text ); } }  $H_tweet_meta = array ( 'id' => $id , 'tweet_text' => $tweet_text , 'date' => $date , 'date2' => $date2 , 'user_id' => $user_id , 'user_name' => $user_name , 'screen_name' => $screen_name , 'url' => $url , 'user_description' => $user_description , 'source' => $source , 'tweet_count' => $tweet_count , 'friends_count' => $friends_count , 'followers_count' => $followers_count , 'retweet_count' => $retweet_count , 'favourites_count' => $favourites_count , 'user_lang' => $user_lang , 'user_icon' => $user_icon , 'media_urls' => $media_urls , 'media_url1' => $media_url1 , 'media_url2' => $media_url2 , 'media_url3' => $media_url3 , 'media_url4' => $media_url4 , 'AUTO_LINK' => 1 , 'HASH_LINK' => 1 , 'USER_LINK' => 1 , );  $tweet_text = $this->TWEET_CHANGE_FORMAT( $tweet_text , $official_format , $official_format_exp = 1 , $H_tweet_meta ); $A_tweets[] = $tweet_text; } } } ?>

<?php
  if( $A_tweets ) { ?>
<div class="uk-alert mhs-notice-default">
	<p>自分のタイムラインを<?php echo count( $A_tweets ); ?>件表示</p>
</div>
<?php
 echo implode( "\n" , $A_tweets ); } ?>

</div>
<?php
 }  function TWEET_CHANGE_FORMAT( $tweet_text , $official_format="" , $official_format_exp=1 , $H_tweet_meta=array() ) { if(! $H_tweet_meta or ! $tweet_text ) { return; }  extract( $H_tweet_meta );  $tweet_link_text= $this->TWEET_LINKER( $tweet_text , $AUTO_LINK , $HASH_LINK , $USER_LINK );  $data_cards = '';  if(! $official_format_exp ) { $data_cards = 'data-cards="hidden"'; }  $official_format = str_replace( '{{TWEET_ID}}' , $id, $official_format ); $official_format = str_replace( '{{TWEET_TEXT}}', $tweet_text, $official_format ); $official_format = str_replace( '{{TWEET_LINKED_TEXT}}', $tweet_link_text, $official_format ); $official_format = str_replace( '{{USER_NAME}}', $user_name, $official_format ); $official_format = str_replace( '{{SCREEN_NAME}}', $screen_name, $official_format ); $official_format = str_replace( '{{URL}}', $url, $official_format ); $official_format = str_replace( '{{DATE}}', $date, $official_format ); $official_format = str_replace( '{{DATE2}}', $date2, $official_format ); $official_format = str_replace( '{{USER_ICON}}', $user_icon, $official_format ); $official_format = str_replace( '{{USER_LANG}}', $user_lang, $official_format ); $official_format = str_replace( '{{MEDIA_URL1}}', $media_url1, $official_format ); $official_format = str_replace( '{{MEDIA_URL2}}', $media_url2, $official_format ); $official_format = str_replace( '{{MEDIA_URL3}}', $media_url3, $official_format ); $official_format = str_replace( '{{MEDIA_URL4}}', $media_url4, $official_format ); $official_format = str_replace( '{{DATA_CARDS}}', $data_cards, $official_format );  $mhs_Utility = new mhs_Utility2();  if(! $media_url1 ) {  $official_format = $mhs_Utility->CHANGE_FORMAT( $official_format , 'media1' , '' ); }  if(! $media_url2 ) {  $official_format = $mhs_Utility->CHANGE_FORMAT( $official_format , 'media2' , '' ); }  if(! $media_url3 ) {  $official_format = $mhs_Utility->CHANGE_FORMAT( $official_format , 'media3' , '' ); }  if(! $media_url4 ) {  $official_format = $mhs_Utility->CHANGE_FORMAT( $official_format , 'media4' , '' ); }  $official_format = preg_replace( '/\{\{.*?\}\}/' , '' , $official_format ); return $official_format; }  function TWEET_LINKER( $tweet , $auto_link = 0 , $hash_link = 0 , $user_link = 0 ) {  if( $auto_link ) {  $pat = '/(?<!href=")https?:\/\/[-_.!~*\'()a-zA-Z0-9;\/?:@&=+$,%#]+/';  $tweet = preg_replace_callback( $pat , function( $matches ) use ( $link_title ) {  $link_title = $matches[ 0 ];  return "<a href=\"{$matches[0]}\" rel=\"nofollow\" target=\"_blank\">$link_title</a>"; }, $tweet ); }  if( $hash_link ) {  $pat2 = '/#(w*[一-龠_ぁ-ん_ァ-ヴー～]+|[a-zA-Z0-9]+|[a-zA-Z0-9]+|[\.\-\@\?\:\;\/\=\%\$\#\!\+\*\_]w*)/u'; $rep2 = '<a href="https://twitter.com/hashtag/$1?src=hash" target="_blank">#$1</a>';  $tweet = preg_replace( $pat2 , $rep2 , $tweet ); }  if( $user_link ) {  $pat3 = '/(?<=^|(?<=[^a-zA-Z0-9-_\.]))@([A-Za-z]+[A-Za-z0-9_]+)/i'; $rep3 = '<a href="https://twitter.com/$1" target="_blank">@$1</a>';  $tweet = preg_replace( $pat3 , $rep3 , $tweet ); } return $tweet; }  function DBT( $mode = 0 ) { if( $mode ) { echo "<pre>"; print_r( debug_backtrace() ); echo "</pre>"; } else {  if( is_user_logged_in() ) { echo "<pre>"; print_r( debug_backtrace() ); echo "</pre>"; } } }  function DMPF( $data , $file_name = "test.txt" , $mode = 0 , $max_byte = 1048576 ) {  ob_start(); var_dump( $data ); $result = ob_get_contents(); ob_end_clean();  if( $mode ) { $fp = fopen( dirname(__FILE__) . "/$file_name" , "a" ); $result .= "\n"; }  else { $fp = fopen( dirname(__FILE__) . "/$file_name" , "w" ); }  fwrite( $fp , $result , $max_byte ); fclose( $fp ); }  function DMP( $value , $option = NULL ) {  if( $option == 1 ) { echo "<pre>"; var_dump( $value ); echo "</pre>"; } else if( $option == 2 ) {  if( is_user_logged_in() ) { echo "<pre>"; var_dump( $value ); echo "</pre>"; } }  else {  if( is_user_logged_in() ) { echo "<pre>"; var_dump( $value ); echo "</pre>"; } } } } 