<?php
defined( 'ABSPATH' ) || exit; 
/*
Description: WordPressのUtility系クラス。
Version: 1.1
Author: 阿修羅ワークス
Author URI: https://wp-plugin.info/
Last Update: 2024-03-01
Changelog: RANDOM_FRONT_REAR関数を追加
2024-03-01 1.1 RANDOM_FRONT_REAR関数を追加
2023-12-02 1.0 ARRAY_MERGE関数を追加
2023-12-02 0.9 CONTENT_2_KEYWORD関数を追加
2023-12-02 0.8 RAND_ARRAY_DIVIDE関数を追加
2023-10-05 0.7 ESC_HTML関数を修正
2023-01-26 0.6 NO4B関数を追加
2023-01-18 0.5 CHANGE_FORMAT関数を追加
2022-11-29 0.4 SORT_ARRAY_BY_KEY関数を追加
2022-11-17 0.3 フォームのエスケープを復元するUNESCAPE関数を追加
2022-05-14 0.2 中途半端に残った括弧を削除する CUT_BRACKETS関数を追加
2022-03-17 0.1 初リリース
*/
 class mhs_Utility2 {   function CHANGE_FORMAT( $string , $keyword , $replace_txt = '' , $ts = '<!--' , $te = '-->' , $td = '/' ) { $ts = preg_quote( $ts , '/' ); $te = preg_quote( $te , '/' ); $td = preg_quote( $td , '/' ); $keyword = preg_quote( $keyword , '/' ); $pat = '/' . $ts . '\s*?' . $keyword . '\s*?' . $te . '.*?' . $ts . '\s*?' . $td . $keyword . '\s*?' . $te . '/is';  $string = preg_replace( $pat , $replace_txt , $string ); return $string; }  function CHANGE_PLACEHOLDER( $content , $H_arg = array() , $left = '{{' , $right = '}}' , $del_remain = 0 ) { if(! $H_arg ) { return $content; } foreach( (array)$H_arg as $key => $val) { if( is_array( $key ) or is_array( $val ) ) continue; $content = str_replace( $left . $key . $right , $val , $content ); }  if( $del_remain ) { $left = preg_quote( $left , '/' ); $right = preg_quote( $right , '/' );  $pat = '/' . $left . '.*?' . $right . '/';  $content = preg_replace( $pat , '' , $content ); } return $content; }  function STRING_2_HASH( $string )  { $H_array = array();  $string = str_replace( '#N' , "\n" , $string );  foreach( explode( "\n" , $string ) as $value ) {  if(! $value ) { continue; }  $value = rtrim( $value );  list( $key , $value ) = explode( "::" , $value );  list( $val_key , $val_value ) = explode( "==" , $value );  if( $val_value ) {  $H_array[ $key ][ $val_key ] = $val_value; }  else {  $H_array[ $key ] = $value; } } return $H_array; }  function ARRAY_SEPARATOR( $delimita = "\n" , $string )  {  if(! $string or is_array( $string ) ) { return; } $array = explode( $delimita , $string ); $array = array_map( "trim" , $array ); return array_values( array_filter( $array , "strlen" ) ); }  function RAND_ARRAY_DIVIDE( $string , $delimita = "\n" ) { if(! $string ) { return; } $A_array = array();  foreach( explode( $delimita , $string ) as $val ) {  $A_array[] = trim( $val ); }  $res = $A_array[ array_rand( $A_array ) ]; return $res; }  function ARRAY_MERGE( $array1 = array() , $array2 = array() ) {   if (! $array1 and ! $array2 ) return array(); else if ( $array1 and ! $array2 ) return $array1; else if (! $array1 and $array2 ) return $array2; $array = array(); foreach( (array)$array1 as $key1 => $val1 ) { $array[ $key1 ] = $val1; foreach( (array)$array2 as $key2 => $val2 ) {  if( is_int( $key2 ) ) {  if( is_array( $val2 ) ) { continue; }  else if(! in_array( $val2 , $array , true ) ) { $array[] = $val2; } }  else { $array[ $key2 ] = $val2; } } } return $array; }  function RANDOM_FRONT_REAR( $string , $random_pre = '' , $random_pos = '' ) { if(! $string ) return;  if( $random_pre ) $A_title_pre = array_map( 'trim' , explode( "\n" , $random_pre ) ); if( $random_pos ) $A_title_pos = array_map( 'trim' , explode( "\n" , $random_pos ) );  if( $A_title_pre ) {  $string = $A_title_pre[ array_rand( $A_title_pre ) ] . $string; }  if( $A_title_pos ) {  $string = $string . $A_title_pos[ array_rand( $A_title_pos ) ]; } return $string; }  function ESC_HTML( $array = array() ) { foreach( (array)$array as $key => $val ) {  if( is_array( $val ) ) continue;   if( strtoupper( $val ) == "UNDEFINED" or strtoupper( $val ) == "NULL" ) { $val = null; }  $array[ $key ] = esc_html( $val ); } return $array; }  function UNESCAPE( $string = null , $A_skip_key = null , $double = 1 , $single = 1 , $cash = 1 ) { if(! $string ) { return $string; }  if( is_array( $string ) ) { foreach( $string as $key => $val ) {  if( $A_skip_key and in_array( $key , $A_skip_key , true ) ) { continue; }  if( $double ) { $string[ $key ] = str_replace( '\"' , '"' , $string[ $key ] ); } if( $double ) { $string[ $key ] = str_replace( '&quot;' , '"' , $string[ $key ] ); }  if( $single ) { $string[ $key ] = str_replace( "\'" , "'" , $string[ $key ] ); } if( $single ) { $string[ $key ] = str_replace( '&#039;' , "'" , $string[ $key ] ); }  if( $cash ) { $string[ $key ] = str_replace( '\\\\' , '\\' , $string[ $key ] ); } } }  else {  if( $double ) { $string = str_replace( '\"' , '"' , $string ); } if( $double ) { $string = str_replace( '&quot;' , '"' , $string ); }  if( $single ) { $string = str_replace( "\'" , "'" , $string ); } if( $single ) { $string = str_replace( '&#039;' , "'" , $string ); }  if( $cash ) { $string = str_replace( '\\\\' , '\\' , $string ); } } return $string; }  function NOSP( $str = null ) { if(! $str ) return $str;  $str = trim( preg_replace( "/\s+/" , " " , $str ) );  $str = trim( preg_replace( "/(\r\n){3,}|\r{3,}|\n{3,}/" , "\n\n" , $str ) ); return $str; }  function NO4B( $str = null , $rep = null ) { if(! $str ) return $str;  $str = preg_replace( '/[\xF0-\xF7][\x80-\xBF][\x80-\xBF][\x80-\xBF]/' , $rep , $str ); return $str; }  function CUT_BRACKETS( $string = null , $brackets = "「::」\n【::】\n『::』\n(::)\n［::］\n（::）\n｛::｝\n{::}\n[::]\n\"::\"\n'::'" ) { if(! $string ) return $string; $H_brackets = $this->STRING_2_HASH( $brackets );  foreach( (array)$H_brackets as $bracket1 => $bracket2 ) {  if( strpos( $string , $bracket1 ) === false ) continue;  $num1 = mb_substr_count( $string , $bracket1 );  $num2 = mb_substr_count( $string , $bracket2 );  if( $num1 == $num2 ) continue;  $last_pos = mb_strrpos( $string , $bracket1 );  $string = mb_substr( $string , 0 , $last_pos ); } return $string; }  function SORT_ARRAY_BY_KEY( &$array, $sortKey, $sortType = SORT_DESC ) { if(! $array or ! is_array( $array ) ) return;    $tmpArray = array(); foreach( (array)$array as $key => $row ) { $tmpArray[ $key ] = $row[ $sortKey ]; } array_multisort( $tmpArray , $sortType , $array ); unset( $tmpArray ); }  function REG_REPLACE( $string , $reg_pat_list , $error_flag = 1 )  {   if(! $string or ! $reg_pat_list ) { return $string; }  if( $reg_pat_list ) { $H_regs = $this->STRING_2_HASH( $reg_pat_list ); }  if(! $H_regs ) { return $string; }  foreach( $H_regs as $key => $val ) { $A_pat = array( "\\\\" , '\"' , "\'" , '&lt;' , '&gt;' , '&quot;' , '&#039;' ); $A_rep = array( "\\" , '"' , "'" , '<' , '>' , '"' , "'" ); $key = str_replace( $A_pat , $A_rep , $key );  try {  if(! $string = @preg_replace( $key , $val , $string ) ) { $error = <<< EOM
<div id="message" class="error notice is-dismissible">
	<p>「正規表現で削除するパターン」にエラーがあります。<br>正規表現のパターンが正しくないようです。</p>
	<button type="button" class="notice-dismiss">
		<span class="screen-reader-text">この通知を非表示にする</span>
	</button>
</div>

EOM;
  throw new Exception( $error ); } }  catch( Exception $e ) { if( $error_flag ) { echo $e->getMessage(); } } } return $string; }  function REPLACE( $string , $replace_list )  {  if(! $string or ! $replace_list ) { return $string; }  if( $replace_list ) { $H_matchs = $this->STRING_2_HASH( $replace_list ); }  if(! $H_matchs ) { return $string; }  foreach( (array)$H_matchs as $key => $val ) {  $string = str_replace( $key , $val , $string ); } return $string; }  function CONTENTS_2_KEYWORD( $content , $border = 0 ) {           if( $border == 1 ) {  preg_match_all( '/[一-龠々]+|[ぁ-ん]+|[ァ-ヴー]+/u' , $content , $result ); }  else if( $border == 2 ) {  preg_match_all( '/[一-龠々]+|[ァ-ヴー]+/u' , $content , $result ); }  else if( $border == 3 ) {  preg_match_all( '/[一-龠々]+/u' , $content , $result ); }  else if( $border == 4 ) {  preg_match_all( '/[ぁ-ん]+|[ァ-ヴー]+/u' , $content , $result ); }  else if( $border == 5 ) {  preg_match_all( '/[ぁ-ん]+/u' , $content , $result ); }  else if( $border == 6 ) {  preg_match_all( '/[ァ-ヴー]+/u' , $content , $result ); }  else if( $border == 7 ) {  preg_match_all( '/[a-zA-Z0-9]+|[ａ-ｚＡ-Ｚ０-９]+/u' , $content , $result ); }  else {  preg_match_all( '/[一-龠]+|[ぁ-ん]+|[ァ-ヴー]+|[a-zA-Z0-9]+|[ａ-ｚＡ-Ｚ０-９]+/u' , $content , $result ); }  $counted_word = array();  foreach( $result as $key => $value ) {  foreach( $value as $key2 => $value2 ) {  if( $counted_word[ $value2 ] ) { $counted_word[ $value2 ] += 1; }  else { $counted_word[ $value2 ] = 1; } } }  arsort( $counted_word ); return $counted_word; }  function DBT( $mode = 0 ) { if( $mode ) { echo "<pre>"; print_r( debug_backtrace() ); echo "</pre>"; } else {  if( is_user_logged_in() ) { echo "<pre>"; print_r( debug_backtrace() ); echo "</pre>"; } } }  function DMPF( $data , $file_name = "test.txt" , $mode = 0 , $max_byte = 1048576 ) {  ob_start(); var_dump( $data ); $result = ob_get_contents(); ob_end_clean();  if( $mode ) { $fp = fopen( dirname(__FILE__) . "/$file_name" , "a" ); $result .= "\n"; }  else { $fp = fopen( dirname(__FILE__) . "/$file_name" , "w" ); }  fwrite( $fp , $result , $max_byte ); fclose( $fp ); }  function DMP( $value , $option = NULL ) {  if( $option == 1 ) { echo "<pre>"; var_dump( $value ); echo "</pre>"; } else if( $option == 2 ) {  if( is_user_logged_in() ) { echo "<pre>"; var_dump( $value ); echo "</pre>"; } }  else {  if( is_user_logged_in() ) { echo "<pre>"; var_dump( $value ); echo "</pre>"; } } } } 