<?php
defined( 'ABSPATH' ) || exit; 
/*
Description: 画像を処理するクラス。
Version: 0.4
Author: 阿修羅ワークス
Author URI: https://wp-plugin.info/
Last Update: 2023-02-22
Changelog: GET_ATACH_FILE_PATH関数を追加
2023-02-22 0.4 GET_ATACH_FILE_PATH関数を追加
2023-02-19 0.3 画像とテキストを合成する関数を追加
2021-07-26 0.2 アバター画像のURLだけを取得できる関数を追加
2021-07-23 0.1 初リリース
*/
 class mhs_Image2 {      function GET_ATTACH_FILE_PATH( $post_id ) { if(! $post_id ) return;  $attach_id = get_post_thumbnail_id( $post_id );  if(! $attach_id ) return;  $H_img_meta = wp_get_attachment_metadata( $attach_id );  $file_path = isset( $H_img_meta[ 'file' ] ) ? $H_img_meta[ 'file' ] : null;  $H_upload = wp_upload_dir();  $file_dir = isset( $H_upload[ 'basedir' ] ) ? $H_upload[ 'basedir' ] : null;  $img_path = $file_dir . '/' . $file_path;  if(! file_exists( $img_path ) ) return; return $img_path; }  function COMPOSIT_IMG( $H_param = array() ) { if(! $H_param or ! is_array( $H_param ) ) return array( 'error' => 'エラー: パラメータがありませんでした。' );  extract( $H_param ); if( $text == '' ) return array( 'error' => 'エラー: 合成する文字列がありませんでした。' ); $font_color = is_null( $font_color ) ? '#000000' : $font_color; $font_width = is_null( $font_width ) ? 0 : $font_width; $width_space = is_null( $width_space ) ? 0 : $width_space; $line_height = is_null( $line_height ) ? 1 : $line_height;  $base_image_path = $base_image_dir . '/' . $base_image_name;  $base_image_path = str_replace( '//' , '/' , $base_image_path );  if(! file_exists( $base_image_path ) ) return array( 'error' => "エラー: 元画像 $base_image_path が存在しませんでした。" );  $H_img_info = getimagesize( $base_image_path );  $width = $H_img_info[ 0 ]; $height = $H_img_info[ 1 ];  $H_image_type = array ( 0 => 'unknown' , 1 => 'gif' , 2 => 'jpeg' , 3 => 'png' , 4 => 'swf' , 5 => 'psd' , 6 => 'bmp' , 7 => 'tiff_ii' , 8 => 'tiff_mm' , 9 => 'jpc' , 10 => 'jp2' , 11 => 'jpx' , 12 => 'jb2' , 13 => 'swc' , 14 => 'iff' , 15 => 'wbmp' , 16 => 'xbm' , 17 => 'ico' , 18 => 'count' );  $img_type = $H_image_type[ $H_img_info[ 2 ] ];  if( $img_type == 'png' ) {  $new_image = imagecreatefrompng( $base_image_path ); $img_type = 'image/png'; }  else if( $img_type == 'jpeg' ) {  $new_image = imagecreatefromjpeg( $base_image_path ); $img_type = 'image/jpeg'; }  else if( $img_type == 'gif' ) {  $new_image = imagecreatefromgif( $base_image_path ); $img_type = 'image/gif'; } else { return array( 'error' => "エラー: $img_type 読み込み可能な画像形式ではありませんでした。" ); }  $fr = hexdec( substr( $font_color , 1 , 2 ) ); $fg = hexdec( substr( $font_color , 3 , 2 ) ); $fb = hexdec( substr( $font_color , 5 , 2 ) );  $fc = imagecolorallocate( $new_image , $fr , $fg , $fb ); $font_dir = is_null( $font_dir ) ? dirname( __FILE__ ) . '/../fonts/' : $font_dir;  $font_path = $font_dir . '/' . $font_file;  $font_path = str_replace( '//' , '/' , $font_path ); if( $font_file and ! file_exists( $font_path ) ) { return array( 'error' => "エラー: $font_path フォントファイルがありませんでした。" ); }  if( is_null( $save_image_dir ) ) {  $H_upload_dir = wp_upload_dir();  $save_image_dir = $H_upload_dir[ 'path' ]; }  $save_img_path = $save_image_dir . '/' . $save_image_name;  $save_img_path = str_replace( '//' , '/' , $save_img_path );  if(! extension_loaded( 'imagick' ) or $mode ) {  $x1 = 0;  $y1 = 0;  $x2 = $width - 1;  $y2 = $height - 1;  $A_box = imageftbbox( $font_size , $angle , $font_path , $text );  $text_width = $A_box[4] - $A_box[0];  $text_height = $A_box[1] - $A_box[5];   $x = $x1 + ( ( $x2 - $x1 - $text_width ) / 2 ); $y = $y1 + ( ( $y2 - $y1 - $text_height ) / 2 ) - $A_box[5];  imagefttext ( $new_image , $font_size , $angle , $x , $y , $fc , $font_path , $text , [ 'linespacing' => $line_height ] , );  if( $img_type == 'image/png' ) {  imagepng( $new_image , $save_img_path ); }  else if( $img_type == 'image/jpeg' ) {  imagejpeg( $new_image , $save_img_path ); }  else if( $img_type == 'image/gif' ) {  imagegif( $new_image , $save_img_path ); }  imagedestroy( $new_image ); }  else {  $im = new Imagick( $base_image_path );    if( $f_width and $f_height ) {  if( $width > $height ) {  $rate = ( $f_height / $height );  $l_width = $f_width * $rate;  $width = $f_width; $height = $f_height;  $im->adaptiveResizeImage( $l_width , $f_height , true ); }  else {  $rate = ( $f_width / $width );  $l_height = $f_height * $rate;  $width = $f_width; $height = $f_height;  $im->adaptiveResizeImage( $f_width , $l_height , true ); }  $im->cropThumbnailImage( $f_width , $f_height); }  if(! $alt_text ) {  $A_wrap_text = $this->IMAGICK_TEXT_WRAP( $text , $width , $width_space , $font_path , $font_size );  $wrap_text = implode( "\n" , $A_wrap_text ); }  else { $wrap_text = $alt_text; }  $draw = new ImagickDraw(); $draw->setFont( $font_path ); $draw->setFontSize( $font_size ); $draw->setStrokeAntialias( true ); $draw->setTextAntialias( true ); $draw->setTextInterlineSpacing( $font_size * $line_height );   $draw->setFillColor( $font_color2 );  $draw->setStrokeWidth( $font_width ); $draw->setStrokeColor( $font_color2 );  $draw->setGravity( Imagick::GRAVITY_CENTER );  $draw->annotation( 0 , 0 , $wrap_text );  $im->drawImage( $draw );  if( $font_color2 ) {  $draw->setFillColor( $font_color );  $draw->setStrokeWidth( $font_width2 ); $draw->setStrokeColor( $font_color );  $draw->annotation( 0 , 0 , $wrap_text );  $im->drawImage( $draw ); }  $im->writeImage( $save_img_path );  $im->destroy(); }  if( $post_id ) { $O_post = get_post( $post_id ); $H_attachment = array ( 'post_author' => $O_post->post_author , 'post_mime_type'=> $img_type , 'post_title' => $text , 'post_content' => '' ,  'post_status' => 'inherit' );  if(! get_post( $post_id ) ) { return array( 'error' => "エラー: 画像を紐づける投稿 $post_id が存在しませんでしたでした。" ); } if(! file_exists( $save_img_path ) ) { return array( 'error' => "エラー: 画像ファイル $save_img_path がありませんでした。" ); }  if( has_post_thumbnail( $post_id ) ) {  $old_attach_id = get_post_thumbnail_id( $post_id );  $H_attachment[ 'ID' ] = $old_attach_id; }  $attach_id = wp_insert_attachment( $H_attachment , $save_img_path , $post_id );  if( $attach_id ) { require_once( ABSPATH . "wp-admin" . '/includes/image.php' ); $attach_data = wp_generate_attachment_metadata( $attach_id , $save_img_path ); $res2 = wp_update_attachment_metadata( $attach_id , $attach_data );  $res3 = update_post_meta( $post_id , '_thumbnail_id' , $attach_id );  $save_img_url = wp_get_attachment_url( $attach_id ); }  else { return array( 'error' => "エラー: 画像ID $attach_id , $upload_url が取得できませんでした。" ); } }  else {  $this_url = (empty($_SERVER['HTTPS']) ? 'http://' : 'https://') . $_SERVER[ 'HTTP_HOST' ] . '/'; $save_img_url = null;  if(! $save_image_dir and strpos( $save_img_path , 'wp-content' ) !== false ) { list( $save_img_url_ , $save_img_url ) = explode( 'wp-content' , $save_img_path );  $save_img_url = $this_url . 'wp-content' . $save_img_url;  $save_img_url = str_replace( '\\' , '/' , $save_img_url ); } } return array( $save_img_url , $save_img_path ); }  function IMAGICK_TEXT_WRAP( $text , $width , $width_space , $font_path , $font_size ) {  $im = new Imagick(); $draw = new ImagickDraw(); $draw->setFont( $font_path ); $draw->setFontSize( $font_size );  $width = $width_space ? ( $width - ( $width_space * $font_size * 2 ) ) : $width;   $_s = ''; $wrappedText = []; while( $text ) {  $_a = mb_substr( $text , 0 , 1 ); $metrics = $im->queryFontMetrics( $draw , $_s . $_a );   if( isset( $metrics[ 'textWidth' ] ) && $metrics[ 'textWidth' ] > $width ) { $wrappedText[] = $_s; $_s = '';   } else { $_s .= $_a; $text = mb_substr($text, 1); }  if( strlen( $text ) == 0 ) { $wrappedText[] = $_s; break; } } return $wrappedText; }  function GET_AVATAR_URL( $id_or_email , $size = null , $default_img_url = null , $alt = null , $H_args = null ) {  $image = get_avatar( $id_or_email , $size , $default_img_url , $alt , $H_args );  if( preg_match( "/src='(.*?)'/" , $image , $A_match ) ) { if( isset( $A_match[ 1 ] ) ) { return $A_match[ 1 ]; } else { return false; } } else { return false; } }  function MEDIA_IMG_RESIZE( $url = null , $width = null , $height = null , $copy = true , $crop = false , $single = false , $upscale = false ) { if(! $url ) return;   if(! function_exists( 'aq_resize' ) ) { require_once( dirname( __FILE__ ) . '/../lib/asura-resizer.php' ); } return aq_resize( $url , $width , $height , $copy , $crop , $single , $upscale ); }  function DBT( $mode = 0 ) { if( $mode ) { echo "<pre>"; print_r( debug_backtrace() ); echo "</pre>"; } else {  if( is_user_logged_in() ) { echo "<pre>"; print_r( debug_backtrace() ); echo "</pre>"; } } }  function DMPF( $data , $file_name = "test.txt" , $mode = 0 , $max_byte = 1048576 ) {  ob_start(); var_dump( $data ); $result = ob_get_contents(); ob_end_clean();  if( $mode ) { $fp = fopen( dirname(__FILE__) . "/$file_name" , "a" ); $result .= "\n"; }  else { $fp = fopen( dirname(__FILE__) . "/$file_name" , "w" ); }  fwrite( $fp , $result , $max_byte ); fclose( $fp ); }  function DMP( $value , $option = NULL ) {  if( $option == 1 ) { echo "<pre>"; var_dump( $value ); echo "</pre>"; } else if( $option == 2 ) {  if( is_user_logged_in() ) { echo "<pre>"; var_dump( $value ); echo "</pre>"; } }  else {  if( is_user_logged_in() ) { echo "<pre>"; var_dump( $value ); echo "</pre>"; } } } }