<?php
defined( 'ABSPATH' ) || exit; 
/*
Description: 類似画像判定クラス。
Version: 0.1
Author: 阿修羅ワークス
Author URI: https://wp-plugin.info/
Last Update: 2020-08-18
Changelog: 初リリース
2020-08-18 0.1 初リリース
*/
 class mhs_SimilarImg2 {   function CHECK_SIMILAR_IMG_RGB( $filepath , $A_search_path = array() , $accuracy = 4 ) {   if(! file_exists( $filepath ) or ! $A_search_path) return;  $sample = $this->LOAD_IMAGE( $filepath );  if(! $sample ) return;  $sample_lab = $this->IMAGE_LAB( $sample , $accuracy );  imagedestroy( $sample ); $files = array(); foreach( (array)$A_search_path as $path ) {  $path = str_replace( '//' , '/' , $path );  if( is_file( $path ) ) $files[] = $path; } $diff = array(); foreach( $files as $file ) {  $image = $this->LOAD_IMAGE( $file );  if(! $image ) continue;  $lab = $this->IMAGE_LAB( $image , $accuracy );  imagedestroy( $image ); $name = basename( $file ); $distance = 0;  foreach( $sample_lab as $key => $value ) {  $distance += $this->LAB_DISTANCE( $value , $lab[ $key ] ); } $diff[ $file ] = $distance; }  asort( $diff ); return $diff; }  function CHECK_SIMILAR_IMGS_RGB( $filepath , $search_dir , $accuracy = 4 ) {   if(! file_exists( $filepath ) ) return;  if(! file_exists( $search_dir ) ) return;  $sample = $this->LOAD_IMAGE( $filepath );  if(! $sample ) return;  $sample_lab = $this->IMAGE_LAB( $sample , $accuracy );  imagedestroy( $sample );  $list = scandir( $search_dir ); $files = array(); foreach( $list as $value ) {  $path = $search_dir . '/' . $value;  $path = str_replace( '//' , '/' , $path );  if( is_file( $path ) ) $files[] = $path; } $diff = array(); foreach( $files as $file ) {  $image = $this->LOAD_IMAGE( $file );  if(! $image ) continue;  $lab = $this->IMAGE_LAB( $image , $accuracy );  imagedestroy( $image ); $name = basename( $file ); $distance = 0;  foreach( $sample_lab as $key => $value ) {  $distance += $this->LAB_DISTANCE( $value , $lab[ $key ] ); } $diff[ $file ] = $distance; }  asort( $diff ); return $diff; }  function LOAD_IMAGE( $filepath ) {  $checkimg = getimagesize( $filepath ); if( $checkimg[ 'mime' ] == "image/jpeg" or $checkimg[ 'mime' ] == "image/pjpeg" ) { $extension = "jpg"; } else if ( $checkimg[ 'mime' ] == "image/gif" ) { $extension = "gif"; } else if ( $checkimg[ 'mime' ] == "image/png" or $checkimg[ 'mime' ] == "image/x-png" ) { $extension = "png"; } else if ( $checkimg[ 'mime' ] == "image/webp" or $checkimg[ 'mime' ] == "image/x-webp" ) { $extension = "webp"; } else { null; }  if( $extension == 'jpg' ) { $image = ImageCreateFromJPEG( $filepath ); } if( $extension == 'gif' ) { $image = ImageCreateFromGIF( $filepath ); } if( $extension == 'png' ) { $image = ImageCreateFromPNG( $filepath ); } if( $extension == 'webp' ) { $image = ImageCreateFromWEBP( $filepath ); } return $image; }  function IMAGE_LAB( $image , $accuracy = 4 ) { $width = imagesx( $image ); $height = imagesy( $image );  $thumb_width = $accuracy; $thumb_height = $accuracy; $thumb = imagecreatetruecolor( $thumb_width , $thumb_height ); imagecopyresampled( $thumb , $image, 0, 0, 0, 0, $thumb_width, $thumb_height, $width, $height ); $lab = array(); $red = 0; $green = 0; $blue = 0; for( $x=0; $x < $thumb_width; $x++ ) { for( $y=0; $y < $thumb_height; $y++ ) { $index = imagecolorat( $thumb , $x , $y ); $rgb = imagecolorsforindex( $thumb , $index );  $lab[] = $this->RGB2LAB( array( $rgb[ 'red' ] , $rgb[ 'green' ] , $rgb[ 'blue' ] ) , $accuracy ); } } return $lab; }  function XYZ2LAB( $xyz , $accuracy = 4 ) { $threshold = 0.008856;   $ref_x = 0.96422; $ref_y = 1.0000; $ref_z = 0.82521; $var_x = $xyz[0] / ( $ref_x * 100 ); $var_y = $xyz[1] / ( $ref_y * 100 ); $var_z = $xyz[2] / ( $ref_z * 100 );  $acc = $accuracy * $accuracy;  $l_renge = 100 + $acc;  $var_x = ( $var_x > $threshold ) ? $var_x = pow( $var_x, 1/3 ) : ( 7.787 * $var_x ) + ( $acc / $l_renge ); $var_y = ( $var_y > $threshold ) ? $var_y = pow( $var_y, 1/3 ) : ( 7.787 * $var_y ) + ( $acc / $l_renge ); $var_z = ( $var_z > $threshold ) ? $var_z = pow( $var_z, 1/3 ) : ( 7.787 * $var_z ) + ( $acc / $l_renge );  $l = ( $l_renge * $var_y ) - $acc; $a = 500 * ( $var_x - $var_y ); $b = 200 * ( $var_y - $var_z ); $lab = array(); $lab = array( $l , $a , $b ); return $lab; }  function RGB2XYZ( $rgb ) { $r = $rgb[0] / 255; $g = $rgb[1] / 255; $b = $rgb[2] / 255; $r = ( $r > 0.04045) ? pow( ( $r + 0.055 ) / 1.055, 2.4 ) : $r / 12.92; $g = ( $g > 0.04045) ? pow( ( $g + 0.055 ) / 1.055, 2.4 ) : $g / 12.92; $b = ( $b > 0.04045) ? pow( ( $b + 0.055 ) / 1.055, 2.4 ) : $b / 12.92; $r = $r * 100; $g = $g * 100; $b = $b * 100; $xyz = array();  $xyz[] = $r * 0.4360747 + $g * 0.3850649 + $b * 0.1430804; $xyz[] = $r * 0.2225045 + $g * 0.7168786 + $b * 0.0606169; $xyz[] = $r * 0.0139322 + $g * 0.0971045 + $b * 0.7141733; return $xyz; }  function RGB2LAB( $rgb , $accuracy = 4 ) {  $xyz = $this->RGB2XYZ( $rgb );  $lab = $this->XYZ2LAB( $xyz , $accuracy ); return $lab; }  function LAB_DISTANCE( $p1 , $p2 ) { $dist = sqrt( pow( $p2[0] - $p1[0] , 2 ) + pow( $p2[1] - $p1[1] , 2 ) + pow( $p2[2] - $p1[2] , 2 ) ); return $dist; }  function CHECK_SIMILAR_IMG_HSV( $filepath , $A_search_path = array() , $priority = array( 'h' => 1 , 's' => 1, 'v' => 1 ) , $thumb_width = 16 , $thumb_height = 16 ) {   if(! file_exists( $filepath ) or ! $A_search_path ) return;  $sample = $this->LOAD_IMAGE( $filepath );  if(! $sample ) return;  $sample_hsv = $this->IMAGE_HSV( $sample , $thumb_width , $thumb_height ); imagedestroy( $sample ); $files = array(); foreach( $A_search_path as $path ) {  $path = str_replace( '//' , '/' , $path ); if( is_file( $path ) ) $files[] = $path; } $diff = array(); foreach( $files as $file ) {  $image = $this->LOADIMAGE( $file );  $hsv = $this->IMAGE_HSV( $image , $thumb_width , $thumb_height ); imagedestroy( $image ); $name = basename($file);  $diff[ $file ] = $this->HSV_DISTANCE( $sample_hsv , $hsv , $priority ); }  asort( $diff ); return $diff; }  function CHECK_SIMILAR_IMGS_HSV( $filepath , $search_dir , $priority = array( 'h' => 1 , 's' => 1, 'v' => 1 ) , $thumb_width = 16 , $thumb_height = 16 ) {   if(! file_exists( $filepath ) ) return;  if(! file_exists( $search_dir ) ) return;  $sample = $this->LOAD_IMAGE( $filepath );  if(! $sample ) return;  $sample_hsv = $this->IMAGE_HSV( $sample , $thumb_width , $thumb_height ); imagedestroy( $sample ); $list = scandir( $search_dir ); $files = array(); foreach( $list as $value ) {  $path = $search_dir . '/' . $value;  $path = str_replace( '//' , '/' , $path ); if( is_file( $path ) ) $files[] = $path; } $diff = array(); foreach( $files as $file ) {  $image = $this->LOAD_IMAGE( $file );  $hsv = $this->IMAGE_HSV( $image , $thumb_width , $thumb_height ); imagedestroy( $image ); $name = basename( $file );  $diff[ $file ] = $this->HSV_DISTANCE( $sample_hsv , $hsv , $priority ); }  asort( $diff ); return $diff; }  function IMAGE_HSV( $image , $thumb_width = 16 , $thumb_height = 16 ) { $width = imagesx($image); $height = imagesy($image); $thumb = imagecreatetruecolor( $thumb_width , $thumb_height ); imagecopyresampled( $thumb , $image, 0, 0, 0, 0, $thumb_width , $thumb_height , $width , $height ); $red = 0; $green = 0; $blue = 0; for( $x=0; $x < $thumb_width; $x++ ) { for( $y=0; $y < $thumb_height; $y++ ) { $index = imagecolorat( $thumb , $x , $y ); $rgb = imagecolorsforindex( $thumb , $index ); $red += $rgb[ 'red' ]; $green += $rgb[ 'green' ]; $blue += $rgb[ 'blue' ]; } } $average = array(); $pixel = $thumb_width * $thumb_height; $average[ 'red' ] = round( $red / $pixel ); $average[ 'green' ] = round( $green / $pixel ); $average[ 'blue' ] = round( $blue / $pixel ); return $this->RGB2HSV( $average ); }  function HSV_DISTANCE( $hsv1 , $hsv2 , $priority ) { $dist_h = abs( $hsv1[ 'h' ] - $hsv2[ 'h' ] ); $distance = 0; $distance += min( $dist_h , 360 - $dist_h ) * $priority[ 'h' ]; $distance += abs( $hsv1[ 's' ] - $hsv2[ 's' ] ) * 180 * $priority[ 's' ]; $distance += abs( $hsv1[ 'v' ] - $hsv2[ 'v' ] ) * 180 * $priority[ 'v' ]; return $distance; }  function RGB2HSV( $rgb ) { $r = $rgb[ 'red' ] / 255; $g = $rgb[ 'green' ] / 255; $b = $rgb[ 'blue' ] / 255; $max = max( $r , $g , $b ); $min = min( $r , $g , $b ); $v = $max; if( $max === $min ) { $h = 0; } else if( $r === $max ) { $h = 60 * ( ( $g - $b ) / ( $max - $min ) ) + 0; } else if( $g === $max ) { $h = 60 * ( ( $b - $r ) / ( $max - $min ) ) + 120; } else { $h = 60 * ( ( $r - $g ) / ( $max - $min ) ) + 240; } if( $h < 0 ) $h = $h + 360; $s = ( $v != 0 ) ? ( $max - $min ) / $max : 0; $hsv = array( 'h' => $h , 's' => $s , 'v' => $v ); return $hsv; }  function DBT( $mode = 0 ) { if( $mode ) { echo "<pre>"; print_r( debug_backtrace() ); echo "</pre>"; } else {  if( is_user_logged_in() ) { echo "<pre>"; print_r( debug_backtrace() ); echo "</pre>"; } } }  function DMPF( $data , $file_name = "test.txt" , $mode = 0 , $max_byte = 1048576 ) {  ob_start(); var_dump( $data ); $result = ob_get_contents(); ob_end_clean();  if( $mode ) { $fp = fopen( dirname(__FILE__) . "/$file_name" , "a" ); $result .= "\n"; }  else { $fp = fopen( dirname(__FILE__) . "/$file_name" , "w" ); }  fwrite( $fp , $result , $max_byte ); fclose( $fp ); }  function DMP( $value , $option = NULL ) {  if( $option == 1 ) { echo "<pre>"; var_dump( $value ); echo "</pre>"; } else if( $option == 2 ) {  if( is_user_logged_in() ) { echo "<pre>"; var_dump( $value ); echo "</pre>"; } }  else {  if( is_user_logged_in() ) { echo "<pre>"; var_dump( $value ); echo "</pre>"; } } } } 